/*  File:   main.c 1
 * gakufu ́A16 bit P
 *   p[gṔAŏɃe|(1Ԃɉtl̐jL^B
 *   ̑̃p[g ̃p[g̉ʁiO?PQVjL^B
 *           p[gP̉ʂ͏ɍőiPQVj
 * ȍ~͉ MSB 8 bit̍B PʂŁÃh 60(0x3C)
 *                LSB 7 bit̒
 *     񕪉F10A    lF08A    F04A    \ZF02
 * t_񕪉F18At_lF0CAt_F06At_\ZF03
 *      | 7 6 5 4 3 2 1 0| 7 6 5 4 3 2 1 0 |
 *      |            |  |          |
 *
 *     Language: MPLABX XC8   Target: PIC116F1459
 */

// x  wl(ms)1/16
#define EnvelopeConst 50
// Ɖ̊Ԃ̖(ms)
#define SilentTime    30

#include "xc.h"
#include "gakufu.h"
#define _XTAL_FREQ 32000000
#define SW         RA5
#define SPK        LATA2
#define TRIS_SPK   TRISA2
#define TRIS_LED   TRISA4
#define LED        LATA4
#define p1         0
#define p2         1
#define p3         2
#define p4         3
#define waitStart  0
#define getGakufu  1
#define getOnpu    2
#define onpuStart  3
#define onpuPlay   4
#define onpuLast   5
#define onpuEnd    6
#define gkfEnd     7

#pragma config FOSC = INTOSC, WDTE = OFF, PWRTE = OFF, MCLRE = OFF, CP = OFF
#pragma config CPD = OFF, BOREN = ON, CLKOUTEN = OFF, IESO = OFF, FCMEN = OFF
#pragma config WRT = OFF, PLLEN = OFF, STVREN = ON, BORV = LO, LVP = OFF

// ̍߂萔  for 32MHz Fosc   PWM Freq 16.525kHz
const unsigned int dW_tbl[] = {
//  Do,   Do#,  Re,   Re#,  Mi,   Fa,   Fa#,  So,   So#,  Ra,   Ra#,  Si,
  0,0x112,0x122,0x133,0x146,0x159,0x16E,0x183,0x19B,0x1B3,0x1CD,0x1E8,0x205, //12
    0x224,0x245,0x267,0x28C,0x2B3,0x2DC,0x307,0x336,0x366,0x39A,0x3D1,0x40B,
    0x449,0x48A,0x4CF,0x518,0x566,0x5B8,0x60F,0x66C,0x6CD,0x735,0x7A3,0x817,
    0x892,0x915,0x99F,0xA31,0xACD,0xB71,0xC1F,0xCD8,0xD9B,0xE6A,0xF46,0x102E,
    0x1125,0x122A,0x133E,0x1463,0x159A,0x16E3,0x183F,0x19B0,0x1B37,0x1CD5,0x1E8C,0x205D,
    0x224A,0x2454,0x267D,0x28C7,0x2B34,0x2DC6,0x307E,0x3361,0x366F,0x39AB,0x3D19,0x40BB
};  // 0x892(index 37) S̃h(60 0x3E) ,0xD9B ̓ (440Hz)

unsigned int accWave[] = {0,0,0,0};
unsigned int incWave[] = {0,0,0,0};
unsigned char amp[]  = {0,0,0,0};
unsigned char wave[] = {0,0,0,0};
char SWdown=0;                     // SW tO
char TmpCnt;                       // e|ԃJEg
char SltCnt;                       // ԃJEg
unsigned char tempo;               // 16̎ ms
char TmpFlg[] = {0,0,0,0};         // e| tO
char SltFlg[] = {0,0,0,0};         //  tO
char EnvCnt[] = {1,1,1,1};         // UԃJEg

// vg^Cv
void SWcheck(void);
void EnvelopeCnt(char);
void TempoCnt(void);
void SilentCnt(void);
void Control(char);
unsigned int ReadOnp(char,unsigned int);

void main(void) {
    char pt;
    OSCCON = 0b11110000;     // NbN 8Mhzx4 32MHz
    ANSELA = 0;              // SăfW^IO
    TRIS_SPK = 0;            // SPK RA2 o
    SPK = 0;                 // SPK óu0]
    TRIS_LED = 0;            // LED RC2 o
    LED = 0;                 // LED 
    nWPUEN = 0;              // vAbv L
    // Timer1 ̐ݒ ------------------------------------
    T1CON = 0b00000001;      // Fosc/4 ps 1/1 TMR1ON
    TMR1 = 0xE100;           // +7936 (0.992ms)  Carry
    TMR1IF = 0;              // Timer1tONA
    // Timer2 ̐ݒ ------------------------------------
    T2CON    = 0b00000100;   // PreS 1/1 PostS 1/1
    PR2      = 0x7F;         // JԂg 15.625KHz X 4
    TMR2IF = 0;              // Timer2tONA
    TMR2IE = 1;              // Timer2ݗL
    PEIE = 1;                // ytFݗL
    GIE = 1;                 // ݗL

    while(1){
        if(TMR1IF){                        // 1ms  Carry
            TMR1H = 0xD1;                  //  1ms ݒ
            TMR1IF = 0;
            SWcheck();                     // SW ON̊mF
            EnvelopeCnt(p1);               // U 50ms
            EnvelopeCnt(p2);               // U 50ms
            TempoCnt();                    // e|
            SilentCnt();                   // 
        }
        Control(p1);                       // Part1 o͐
        Control(p2);                       // Part2 o͐
        Control(p3);                       // Part1 o͐
        Control(p4);                       // Part2 o͐
    }   //  while
}
// ݏu --------------------------------------------
void interrupt isr(void){
    static char ch;
    if(TMR2IF){                             // Timer2 ݂mF
        TMR2IF = 0;                         // Timer2 tO@Zbg
        ch++;                               // o͂Partԍi߂
        ch &= 3;                            // ԍ͂O`R܂
        accWave[ch] += incWave[ch];         // partJԂg`XV
        if(STATUSbits.CARRY)wave[ch] ^= 1;  // LoΔ]
        if(wave[ch])CCPR1L = amp[ch];       // g` Hi Ȃamp
        else CCPR1L = 0;                    // g` Low Ȃ[
    }                                       // TCNŏo
}
//------- SW`^Oh~ 1ms[v ----------------
void SWcheck(void){
    static char SWnotRdy = 10;              // SWup̊mF҂
    if(SWnotRdy){                           // SWup̊mFȂ
        if(SW)SWnotRdy--;                   //   SWup̊mF[P
        else SWnotRdy = 10;                 //   SWup̊mFl
    }else if(!SW){                          // SWup̊mFς݂DownȂ
        SWdown = 1;                         //   SWꂽ}[N
        SWnotRdy = 10;                      //   SWup̊mF҂
    }
}
//------- U 50ms -----------------------------------
void EnvelopeCnt(char pt){
    if(EnvCnt[pt]-- == 1){
        EnvCnt[pt] = EnvelopeConst;         // 50ms
        amp[pt] = (int)amp[pt] * 15/16;     // ʂ -6% 
    }
}
//------- e| -----------------------------------
void TempoCnt(void){
    if(TmpCnt-- == 1){
        TmpCnt = tempo;                     // e|
        TmpFlg[p1] = 1;                     // e|tOZbg
        TmpFlg[p2] = 1;
        TmpFlg[p3] = 1;
        TmpFlg[p4] = 1;
    }
}
//-------  -----------------------------------
void SilentCnt(void){
    if(SltCnt-- == 1){                      // ԂɂȂ
        SltFlg[p1] = 1;                     // tOZbg
        SltFlg[p2] = 1;
        SltFlg[p3] = 1;
        SltFlg[p4] = 1;
    }
}
//------- 吧 -----------------------------------
void Control(char pt){
    static char state[] = {0,0,0,0};
    static unsigned int  pOnp[]  = {0,0,0,0};    // ʒu
    static unsigned char iAmp[4];                // p[g̉
    static unsigned char tPlay[4];               // t
    static unsigned int  incNext[4];             // 
    static unsigned char ampNext[4];             // 
    unsigned int Onp;                            // 
    char i;
    //---------------------------------------------------------
    switch(state[pt]){
        case waitStart:             // ====== tJn҂ ======
            if(SWdown){                          // SW ̂҂
                if(pt == p1){                    // Part1
                    SWdown=0;                    //  SW ςݖ
                    state[p1] = getGakufu;       //  tJn
                }
            }
            break;
        case getGakufu:             // ====== y̐ݒ ======
            if(p1gkf[pOnp[p1]]==0xFFFF){         // yI[Ȃ
                pOnp[p1] = 0;                    //   Sp[g̊y
                pOnp[p2] = 0;                    //   擪ɃZbg
                pOnp[p3] = 0;
                pOnp[p4] = 0;
            }
            tempo = 7500/p1gkf[pOnp[p1]];        // ỹe|擾
            TmpCnt = tempo;                      // e|Zbg
            CCP1CON = 0b00111100;                // PWM ON
            TMR2ON = 1;                          // Timer2 ON
            for(i=0;i<=3;i++){                   // Sp[g
                iAmp[i] = ReadOnp(i, pOnp[i]++); //   ʎ擾
                TmpFlg[i] = 0;                   //   e|tOZbg
                state[i] = getOnpu;              //   ݒ
            }
            iAmp[p1] = 0x7F;                     // Part1 ʂ͏ɍő
            break;
        case getOnpu:               // ====== ̐ݒ ======
            Onp = ReadOnp(pt, pOnp[pt]++);       // Yy特擾
            if(Onp == 0xFFFF){                   // Part̏IȂ
                state[pt] = gkfEnd;              //   ȏI
                break;
            }
            tPlay[pt] = Onp & 0x7F;              // tԂɕϊ
            Onp = Onp >> 8;                      // ̍o
            if((Onp>23)&(Onp<96)){               // Ȃ
                incNext[pt] = dW_tbl[Onp - 23];  //   JԂԂɕϊ
                ampNext[pt] = iAmp[pt];          //   ő剹
            }else{                               // xȂ
                incNext[pt] = 0;                 //   JԂ@Ȃ
                ampNext[pt] = 0;                 //   OFF
            }
            state[pt] = onpuStart;               // tJn
            break;
        case onpuStart:             // ====== ̉tJn ======
            if(TmpFlg[pt]){                      // e|҂
                TmpFlg[pt] = 0;                  // ̉tXV
                incWave[pt] = incNext[pt];       // JԂPʃZbg
                accWave[pt] = 0;                 // g`JԂZbg
                wave[pt] = 0;                    // g` OFF
                EnvCnt[pt] = EnvelopeConst;      // ʌ^C}Zbg
                amp[pt] = ampNext[pt];           // ʃZbg
                if(pt==p1){                      // p[g
                    if(amp[0])LED=1;             // ȂLED_
                    else LED=0;                  // xȂLED
                }
//                if(amp[pt])LATC |= 1 << pt;    // ȂLED_
                state[pt] = onpuPlay;            // tp
            }
            break;
        case onpuPlay:             // ====== ̉tp ======
            if(TmpFlg[pt]){                      // e|҂
                TmpFlg[pt] = 0;                  // e|tOZbg
                if(tPlay[pt]-- == 2)             // ̉tIȂ
                    state[pt] = onpuLast;        //   ̖ݒ
                if(SWdown){                      // SW
                    state[p1] = gkfEnd;          //   Ȃ̏I
                    SWdown=0;                    //   SW ςݖ
                }
            }
            break;
        case onpuLast:             // ====== ̖Ԑݒ ======
            if(pt==p1)LED = 0;                   // LED OFF
            SltCnt = tempo - SilentTime;         // ԂZbg
            SltFlg[pt] = 0;                      // tOZbg
            state[pt] = onpuEnd;                 // ̎ԏI
            break;
        case onpuEnd:             // ====== ̉tI ======
            if(SltFlg[pt]){                      // tIԂ҂
                amp[pt] = 0;                     // OFF
                state[pt] = getOnpu;             // ̉擾
            }
            break;
        case gkfEnd:              // ====== ỷtI ======
            if(pt == p1){                        // Part 1 IȂ
                LED = 0;                         //   LED
                CCP1CON = 0;                     //   PWM OFF
                TMR2ON = 0;                      //   Timer2 OFF
                for(i=0;i<=3;i++){               //   SPartƂ
                    pOnp[i]--;                   //       ȏI܂Ői
                    while(ReadOnp(i, pOnp[i]++) != 0xFFFF);
                    state[i] = waitStart;        //       tJn҂
                }
            }else{                               // Part 1 ȊOȂ
                amp[pt] = 0;                     //   YOFF
                incWave[pt] = 0;                 //   JԂP O
                state[pt] = waitStart;           //   ȉt҂
            }
            break;
    }
}
// w part ̊yw index ̉擾
unsigned int ReadOnp(char part, unsigned int index){
    switch(part){
        case p1:return p1gkf[index];
        case p2:return p2gkf[index];
        case p3:return p3gkf[index];
        case p4:return p4gkf[index];
    }
    return 0;
}
